
ModbusSlave_coilState:

;ModbusSlave.c,74 :: 		static boolean coilState(uint uintAddress, boolean blnState) {
;ModbusSlave.c,75 :: 		if ( pCurrBlock != NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState148
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+0, 0 
L_ModbusSlave_coilState148:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState0
;ModbusSlave.c,79 :: 		uintOffset = uintAddress - pCurrBlock->uintAddress;
	MOVLW       2
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_coilState_uintAddress+0, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_coilState_uintAddress+1, 0 
	MOVWF       R4 
;ModbusSlave.c,80 :: 		bytIndex = uintOffset / 8;
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       R5 
;ModbusSlave.c,81 :: 		bytBit = 1 << (uintOffset % 8);
	MOVLW       7
	ANDWF       R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVLW       1
	MOVWF       R6 
	MOVF        R0, 0 
L_ModbusSlave_coilState149:
	BZ          L_ModbusSlave_coilState150
	RLCF        R6, 1 
	BCF         R6, 0 
	ADDLW       255
	GOTO        L_ModbusSlave_coilState149
L_ModbusSlave_coilState150:
;ModbusSlave.c,83 :: 		if ( blnState == TRUE ) {
	MOVF        FARG_ModbusSlave_coilState_blnState+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState1
;ModbusSlave.c,85 :: 		((byte*)pCurrBlock->paryData)[bytIndex] |= bytBit;
	MOVLW       6
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        R5, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVFF       R1, FSR0
	MOVFF       R2, FSR0H
	MOVF        R6, 0 
	IORWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVFF       R1, FSR1
	MOVFF       R2, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,86 :: 		} else {
	GOTO        L_ModbusSlave_coilState2
L_ModbusSlave_coilState1:
;ModbusSlave.c,88 :: 		((byte*)pCurrBlock->paryData)[bytIndex] &= (0xff ^ bytBit);
	MOVLW       6
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        R5, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       255
	XORWF       R6, 0 
	MOVWF       R0 
	MOVFF       R1, FSR0
	MOVFF       R2, FSR0H
	MOVF        POSTINC0+0, 0 
	ANDWF       R0, 1 
	MOVFF       R1, FSR1
	MOVFF       R2, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,89 :: 		}
L_ModbusSlave_coilState2:
;ModbusSlave.c,90 :: 		pCurrBlock->blnUpdate = TRUE;
	MOVLW       8
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR1H 
	MOVLW       1
	MOVWF       POSTINC1+0 
;ModbusSlave.c,91 :: 		return TRUE;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_coilState
;ModbusSlave.c,92 :: 		}
L_ModbusSlave_coilState0:
;ModbusSlave.c,93 :: 		return FALSE;
	CLRF        R0 
;ModbusSlave.c,94 :: 		}
L_end_coilState:
	RETURN      0
; end of ModbusSlave_coilState

ModbusSlave_packBits:

;ModbusSlave.c,109 :: 		uint uintStart, uint uintEnd) {
;ModbusSlave.c,112 :: 		uint uintBytes = 0;
	CLRF        ModbusSlave_packBits_uintBytes_L0+0 
	CLRF        ModbusSlave_packBits_uintBytes_L0+1 
;ModbusSlave.c,114 :: 		if ( eType == COILS ) {
	MOVF        FARG_ModbusSlave_packBits_eType+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits3
;ModbusSlave.c,115 :: 		pNode = pCoils;
	MOVF        _pCoils+0, 0 
	MOVWF       R8 
	MOVF        _pCoils+1, 0 
	MOVWF       R9 
;ModbusSlave.c,116 :: 		} else if( eType == STATUS_INPUTS ) {
	GOTO        L_ModbusSlave_packBits4
L_ModbusSlave_packBits3:
	MOVF        FARG_ModbusSlave_packBits_eType+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits5
;ModbusSlave.c,117 :: 		pNode = pStatusBits;
	MOVF        _pStatusBits+0, 0 
	MOVWF       R8 
	MOVF        _pStatusBits+1, 0 
	MOVWF       R9 
;ModbusSlave.c,118 :: 		} else {
	GOTO        L_ModbusSlave_packBits6
L_ModbusSlave_packBits5:
;ModbusSlave.c,119 :: 		return 0;
	CLRF        R0 
	CLRF        R1 
	GOTO        L_end_packBits
;ModbusSlave.c,120 :: 		}
L_ModbusSlave_packBits6:
L_ModbusSlave_packBits4:
;ModbusSlave.c,121 :: 		while( pNode != NULL ) {
L_ModbusSlave_packBits7:
	MOVLW       0
	XORWF       R9, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits152
	MOVLW       0
	XORWF       R8, 0 
L_ModbusSlave_packBits152:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits8
;ModbusSlave.c,122 :: 		if ( uintStart >= pNode->uintAddress ) {
	MOVLW       2
	ADDWF       R8, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintStart+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits153
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintStart+0, 0 
L_ModbusSlave_packBits153:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packBits9
;ModbusSlave.c,123 :: 		break;
	GOTO        L_ModbusSlave_packBits8
;ModbusSlave.c,124 :: 		}
L_ModbusSlave_packBits9:
;ModbusSlave.c,125 :: 		pNode = pNode->pNext;
	MOVLW       13
	ADDWF       R8, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R8 
	MOVF        POSTINC0+0, 0 
	MOVWF       R9 
;ModbusSlave.c,126 :: 		}
	GOTO        L_ModbusSlave_packBits7
L_ModbusSlave_packBits8:
;ModbusSlave.c,127 :: 		if ( pNode != NULL && uintEnd < pNode->uintAddress + pNode->uintTotal ) {
	MOVLW       0
	XORWF       R9, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits154
	MOVLW       0
	XORWF       R8, 0 
L_ModbusSlave_packBits154:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits12
	MOVLW       2
	ADDWF       R8, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       R1 
	MOVLW       4
	ADDWF       R8, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR2H 
	MOVFF       R0, FSR0
	MOVFF       R1, FSR0H
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits155
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+0, 0 
L_ModbusSlave_packBits155:
	BTFSC       STATUS+0, 0 
	GOTO        L_ModbusSlave_packBits12
L_ModbusSlave_packBits135:
;ModbusSlave.c,131 :: 		uintOffset = uintStart - pNode->uintAddress;
	MOVLW       2
	ADDWF       R8, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintStart+0, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_packBits_uintStart+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R5 
	MOVF        R4, 0 
	MOVWF       R6 
;ModbusSlave.c,133 :: 		bytIndex = uintOffset / 8;
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       R7 
;ModbusSlave.c,135 :: 		Hi(uintOffset) = 1 << (Lo(uintOffset) & 7);
	MOVLW       7
	ANDWF       R5, 0 
	MOVWF       R0 
	MOVLW       1
	MOVWF       R6 
	MOVF        R0, 0 
L_ModbusSlave_packBits156:
	BZ          L_ModbusSlave_packBits157
	RLCF        R6, 1 
	BCF         R6, 0 
	ADDLW       255
	GOTO        L_ModbusSlave_packBits156
L_ModbusSlave_packBits157:
;ModbusSlave.c,137 :: 		Lo(uintOffset) = 1;
	MOVLW       1
	MOVWF       R5 
;ModbusSlave.c,139 :: 		*pBuffer = 0;
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR1
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR1H
	CLRF        POSTINC1+0 
;ModbusSlave.c,140 :: 		while( uintStart <= uintEnd ) {
L_ModbusSlave_packBits13:
	MOVF        FARG_ModbusSlave_packBits_uintStart+1, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits158
	MOVF        FARG_ModbusSlave_packBits_uintStart+0, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+0, 0 
L_ModbusSlave_packBits158:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packBits14
;ModbusSlave.c,141 :: 		if ( Lo(uintOffset).B0 ) {
	BTFSS       R5, 0 
	GOTO        L_ModbusSlave_packBits15
;ModbusSlave.c,142 :: 		uintBytes++;
	INFSNZ      ModbusSlave_packBits_uintBytes_L0+0, 1 
	INCF        ModbusSlave_packBits_uintBytes_L0+1, 1 
;ModbusSlave.c,143 :: 		}
L_ModbusSlave_packBits15:
;ModbusSlave.c,145 :: 		if ( (((byte*)pNode->paryData)[bytIndex] & Hi(uintOffset)) ) {
	MOVLW       6
	ADDWF       R8, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R7, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        R6, 0 
	ANDWF       POSTINC0+0, 0 
	MOVWF       R0 
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits16
;ModbusSlave.c,146 :: 		*pBuffer |= Lo(uintOffset);
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR0
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR0H
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR1
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR1H
	MOVF        R5, 0 
	IORWF       POSTINC0+0, 1 
;ModbusSlave.c,147 :: 		}
L_ModbusSlave_packBits16:
;ModbusSlave.c,148 :: 		Hi(uintOffset) <<= 1;
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       R6 
;ModbusSlave.c,150 :: 		if ( Hi(uintOffset) == 0 ) {
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits17
;ModbusSlave.c,151 :: 		Hi(uintOffset) = 1;
	MOVLW       1
	MOVWF       R6 
;ModbusSlave.c,152 :: 		bytIndex++;
	INCF        R7, 1 
;ModbusSlave.c,153 :: 		}
L_ModbusSlave_packBits17:
;ModbusSlave.c,154 :: 		Lo(uintOffset) <<= 1;
	RLCF        R5, 1 
	BCF         R5, 0 
;ModbusSlave.c,156 :: 		if ( Lo(uintOffset) == 0 ) {
	MOVF        R5, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits18
;ModbusSlave.c,157 :: 		Lo(uintOffset) = 1;
	MOVLW       1
	MOVWF       R5 
;ModbusSlave.c,158 :: 		pBuffer++;
	INFSNZ      FARG_ModbusSlave_packBits_pBuffer+0, 1 
	INCF        FARG_ModbusSlave_packBits_pBuffer+1, 1 
;ModbusSlave.c,159 :: 		*pBuffer = 0;
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR1
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR1H
	CLRF        POSTINC1+0 
;ModbusSlave.c,160 :: 		}
L_ModbusSlave_packBits18:
;ModbusSlave.c,162 :: 		uintStart++;
	INFSNZ      FARG_ModbusSlave_packBits_uintStart+0, 1 
	INCF        FARG_ModbusSlave_packBits_uintStart+1, 1 
;ModbusSlave.c,163 :: 		}
	GOTO        L_ModbusSlave_packBits13
L_ModbusSlave_packBits14:
;ModbusSlave.c,164 :: 		}
L_ModbusSlave_packBits12:
;ModbusSlave.c,165 :: 		return uintBytes;
	MOVF        ModbusSlave_packBits_uintBytes_L0+0, 0 
	MOVWF       R0 
	MOVF        ModbusSlave_packBits_uintBytes_L0+1, 0 
	MOVWF       R1 
;ModbusSlave.c,166 :: 		}
L_end_packBits:
	RETURN      0
; end of ModbusSlave_packBits

ModbusSlave_packRegisters:

;ModbusSlave.c,181 :: 		uint uintStart, uint uintEnd) {
;ModbusSlave.c,184 :: 		uint uintBytes = 0;
	CLRF        ModbusSlave_packRegisters_uintBytes_L0+0 
	CLRF        ModbusSlave_packRegisters_uintBytes_L0+1 
;ModbusSlave.c,186 :: 		if ( eType == HOLDING_REGISTERS ) {
	MOVF        FARG_ModbusSlave_packRegisters_eType+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters19
;ModbusSlave.c,187 :: 		pNode = pHoldingRegs;
	MOVF        _pHoldingRegs+0, 0 
	MOVWF       R7 
	MOVF        _pHoldingRegs+1, 0 
	MOVWF       R8 
;ModbusSlave.c,188 :: 		} else if( eType == INPUT_REGISTERS ) {
	GOTO        L_ModbusSlave_packRegisters20
L_ModbusSlave_packRegisters19:
	MOVF        FARG_ModbusSlave_packRegisters_eType+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters21
;ModbusSlave.c,189 :: 		pNode = pInputRegs;
	MOVF        _pInputRegs+0, 0 
	MOVWF       R7 
	MOVF        _pInputRegs+1, 0 
	MOVWF       R8 
;ModbusSlave.c,190 :: 		} else {
	GOTO        L_ModbusSlave_packRegisters22
L_ModbusSlave_packRegisters21:
;ModbusSlave.c,191 :: 		return 0;
	CLRF        R0 
	CLRF        R1 
	GOTO        L_end_packRegisters
;ModbusSlave.c,192 :: 		}
L_ModbusSlave_packRegisters22:
L_ModbusSlave_packRegisters20:
;ModbusSlave.c,193 :: 		while( pNode != NULL ) {
L_ModbusSlave_packRegisters23:
	MOVLW       0
	XORWF       R8, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters160
	MOVLW       0
	XORWF       R7, 0 
L_ModbusSlave_packRegisters160:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters24
;ModbusSlave.c,194 :: 		if ( uintStart >= pNode->uintAddress ) {
	MOVLW       2
	ADDWF       R7, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintStart+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters161
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintStart+0, 0 
L_ModbusSlave_packRegisters161:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packRegisters25
;ModbusSlave.c,195 :: 		break;
	GOTO        L_ModbusSlave_packRegisters24
;ModbusSlave.c,196 :: 		}
L_ModbusSlave_packRegisters25:
;ModbusSlave.c,197 :: 		pNode = pNode->pNext;
	MOVLW       13
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R7 
	MOVF        POSTINC0+0, 0 
	MOVWF       R8 
;ModbusSlave.c,198 :: 		}
	GOTO        L_ModbusSlave_packRegisters23
L_ModbusSlave_packRegisters24:
;ModbusSlave.c,199 :: 		if ( pNode != NULL && uintEnd < (pNode->uintAddress + pNode->uintTotal) ) {
	MOVLW       0
	XORWF       R8, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters162
	MOVLW       0
	XORWF       R7, 0 
L_ModbusSlave_packRegisters162:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters28
	MOVLW       2
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVLW       4
	ADDWF       R7, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters163
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+0, 0 
L_ModbusSlave_packRegisters163:
	BTFSC       STATUS+0, 0 
	GOTO        L_ModbusSlave_packRegisters28
L_ModbusSlave_packRegisters136:
;ModbusSlave.c,201 :: 		uintOffset = uintStart - pNode->uintAddress;
	MOVLW       2
	ADDWF       R7, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintStart+0, 0 
	MOVWF       R5 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_packRegisters_uintStart+1, 0 
	MOVWF       R6 
;ModbusSlave.c,202 :: 		while( uintStart <= uintEnd ) {
L_ModbusSlave_packRegisters29:
	MOVF        FARG_ModbusSlave_packRegisters_uintStart+1, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters164
	MOVF        FARG_ModbusSlave_packRegisters_uintStart+0, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+0, 0 
L_ModbusSlave_packRegisters164:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packRegisters30
;ModbusSlave.c,203 :: 		pBuffer[uintBytes++] = Hi(((uint*)pNode->paryData)[uintOffset]);
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+0, 0 
	ADDWF       FARG_ModbusSlave_packRegisters_pBuffer+0, 0 
	MOVWF       FSR1 
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+1, 0 
	ADDWFC      FARG_ModbusSlave_packRegisters_pBuffer+1, 0 
	MOVWF       FSR1H 
	MOVLW       6
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVF        R5, 0 
	MOVWF       R0 
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        POSTINC0+0, 0 
	ADDWF       R0, 1 
	MOVF        POSTINC0+0, 0 
	ADDWFC      R1, 1 
	MOVLW       1
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      ModbusSlave_packRegisters_uintBytes_L0+0, 1 
	INCF        ModbusSlave_packRegisters_uintBytes_L0+1, 1 
;ModbusSlave.c,204 :: 		pBuffer[uintBytes++] = Lo(((uint*)pNode->paryData)[uintOffset]);
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+0, 0 
	ADDWF       FARG_ModbusSlave_packRegisters_pBuffer+0, 0 
	MOVWF       FSR1 
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+1, 0 
	ADDWFC      FARG_ModbusSlave_packRegisters_pBuffer+1, 0 
	MOVWF       FSR1H 
	MOVLW       6
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R5, 0 
	MOVWF       R0 
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R3, 0 
	MOVWF       FSR0 
	MOVF        R1, 0 
	ADDWFC      R4, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      ModbusSlave_packRegisters_uintBytes_L0+0, 1 
	INCF        ModbusSlave_packRegisters_uintBytes_L0+1, 1 
;ModbusSlave.c,206 :: 		uintStart++;
	INFSNZ      FARG_ModbusSlave_packRegisters_uintStart+0, 1 
	INCF        FARG_ModbusSlave_packRegisters_uintStart+1, 1 
;ModbusSlave.c,207 :: 		uintOffset++;
	INFSNZ      R5, 1 
	INCF        R6, 1 
;ModbusSlave.c,208 :: 		}
	GOTO        L_ModbusSlave_packRegisters29
L_ModbusSlave_packRegisters30:
;ModbusSlave.c,209 :: 		}
L_ModbusSlave_packRegisters28:
;ModbusSlave.c,210 :: 		return uintBytes;
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+0, 0 
	MOVWF       R0 
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+1, 0 
	MOVWF       R1 
;ModbusSlave.c,211 :: 		}
L_end_packRegisters:
	RETURN      0
; end of ModbusSlave_packRegisters

ModbusSlave_setRegister:

;ModbusSlave.c,224 :: 		static boolean setRegister(uint uintAddress, byte bytDataHi, byte bytDataLo) {
;ModbusSlave.c,225 :: 		if ( pCurrBlock != NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister166
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+0, 0 
L_ModbusSlave_setRegister166:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister31
;ModbusSlave.c,227 :: 		Lo(uintTemp) = bytDataLo;
	MOVF        FARG_ModbusSlave_setRegister_bytDataLo+0, 0 
	MOVWF       R5 
;ModbusSlave.c,228 :: 		Hi(uintTemp) = bytDataHi;
	MOVF        FARG_ModbusSlave_setRegister_bytDataHi+0, 0 
	MOVWF       R6 
;ModbusSlave.c,229 :: 		uintOffset = uintAddress - pCurrBlock->uintAddress;
	MOVLW       2
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_setRegister_uintAddress+0, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_setRegister_uintAddress+1, 0 
	MOVWF       R4 
;ModbusSlave.c,230 :: 		((uint*)pCurrBlock->paryData)[uintOffset] = uintTemp;
	MOVLW       6
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       FSR1 
	MOVF        R1, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       FSR1H 
	MOVF        R5, 0 
	MOVWF       POSTINC1+0 
	MOVF        R6, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,231 :: 		pCurrBlock->blnUpdate = TRUE;
	MOVLW       8
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR1H 
	MOVLW       1
	MOVWF       POSTINC1+0 
;ModbusSlave.c,232 :: 		return TRUE;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_setRegister
;ModbusSlave.c,233 :: 		}
L_ModbusSlave_setRegister31:
;ModbusSlave.c,234 :: 		return FALSE;
	CLRF        R0 
;ModbusSlave.c,235 :: 		}
L_end_setRegister:
	RETURN      0
; end of ModbusSlave_setRegister

_decodePacket:

;ModbusSlave.c,248 :: 		void decodePacket(void) {
;ModbusSlave.c,249 :: 		if ( TMR0IF_bit ) {
	BTFSS       TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
	GOTO        L_decodePacket32
;ModbusSlave.c,250 :: 		bytMbRxphase.B0 = 1;
	BSF         _bytMbRxphase+0, 0 
;ModbusSlave.c,251 :: 		TMR0ON_bit = 0;
	BCF         TMR0ON_bit+0, BitPos(TMR0ON_bit+0) 
;ModbusSlave.c,253 :: 		TMR0IF_bit = 0;
	BCF         TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
;ModbusSlave.c,255 :: 		if ( bytMbRxphase.B7 ) {
	BTFSS       _bytMbRxphase+0, 7 
	GOTO        L_decodePacket33
;ModbusSlave.c,257 :: 		restartRx();
	CALL        _restartRx+0, 0
;ModbusSlave.c,258 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,259 :: 		}
L_decodePacket33:
;ModbusSlave.c,260 :: 		}
L_decodePacket32:
;ModbusSlave.c,261 :: 		if( RCIF_bit ) {
	BTFSS       RCIF_bit+0, BitPos(RCIF_bit+0) 
	GOTO        L_decodePacket34
;ModbusSlave.c,264 :: 		if ( OERR_bit || FERR_bit ) {
	BTFSC       OERR_bit+0, BitPos(OERR_bit+0) 
	GOTO        L__decodePacket146
	BTFSC       FERR_bit+0, BitPos(FERR_bit+0) 
	GOTO        L__decodePacket146
	GOTO        L_decodePacket37
L__decodePacket146:
;ModbusSlave.c,265 :: 		restartRx();
	CALL        _restartRx+0, 0
;ModbusSlave.c,266 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,267 :: 		}
L_decodePacket37:
;ModbusSlave.c,270 :: 		bytTemp = RCREG;
	MOVF        RCREG+0, 0 
	MOVWF       decodePacket_bytTemp_L1+0 
;ModbusSlave.c,273 :: 		if ( bytMbRxphase == 0 || bytMbRxphase.B2 == 1 ||
	MOVF        _bytMbRxphase+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__decodePacket145
	BTFSC       _bytMbRxphase+0, 2 
	GOTO        L__decodePacket145
;ModbusSlave.c,274 :: 		bytMbIndex >= MAX_PACKET_LENGTH ) {
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORLW       1
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket168
	MOVLW       0
	SUBWF       _bytMbIndex+0, 0 
L__decodePacket168:
	BTFSC       STATUS+0, 0 
	GOTO        L__decodePacket145
	GOTO        L_decodePacket40
L__decodePacket145:
;ModbusSlave.c,276 :: 		bytMbIndex = 0;
	CLRF        _bytMbIndex+0 
;ModbusSlave.c,277 :: 		bytMbRxphase = 0;
	CLRF        _bytMbRxphase+0 
;ModbusSlave.c,278 :: 		startTimeout();  // 4.5 chars
	CALL        _startTimeout+0, 0
;ModbusSlave.c,279 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,280 :: 		}
L_decodePacket40:
;ModbusSlave.c,281 :: 		if ( bytMbIndex == 0) {
	MOVF        _bytMbIndex+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket41
;ModbusSlave.c,283 :: 		bytMbRxphase = 2;
	MOVLW       2
	MOVWF       _bytMbRxphase+0 
;ModbusSlave.c,284 :: 		}
L_decodePacket41:
;ModbusSlave.c,286 :: 		arybytMbBuffer[bytMbIndex++] = bytTemp;
	MOVLW       _arybytMbBuffer+0
	MOVWF       FSR1 
	MOVLW       hi_addr(_arybytMbBuffer+0)
	MOVWF       FSR1H 
	MOVF        _bytMbIndex+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVF        decodePacket_bytTemp_L1+0, 0 
	MOVWF       POSTINC1+0 
	INCF        _bytMbIndex+0, 1 
;ModbusSlave.c,288 :: 		startTimeout();  // 2.5 chars
	CALL        _startTimeout+0, 0
;ModbusSlave.c,289 :: 		} else if ( bytMbRxphase.B7 ) {
	GOTO        L_decodePacket42
L_decodePacket34:
	BTFSS       _bytMbRxphase+0, 7 
	GOTO        L_decodePacket43
;ModbusSlave.c,290 :: 		if ( TXIF_bit ) {
	BTFSS       TXIF_bit+0, BitPos(TXIF_bit+0) 
	GOTO        L_decodePacket44
;ModbusSlave.c,291 :: 		if ( bytMbIndex < arybytMbBuffer[0] ) {
	MOVF        _arybytMbBuffer+0, 0 
	SUBWF       _bytMbIndex+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket45
;ModbusSlave.c,292 :: 		TXREG = arybytMbBuffer[bytMbIndex++];
	MOVLW       _arybytMbBuffer+0
	MOVWF       FSR0 
	MOVLW       hi_addr(_arybytMbBuffer+0)
	MOVWF       FSR0H 
	MOVF        _bytMbIndex+0, 0 
	ADDWF       FSR0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       TXREG+0 
	INCF        _bytMbIndex+0, 1 
;ModbusSlave.c,293 :: 		} else {
	GOTO        L_decodePacket46
L_decodePacket45:
;ModbusSlave.c,295 :: 		startTimeout();  // 1 char
	CALL        _startTimeout+0, 0
;ModbusSlave.c,297 :: 		TXIE_bit = 0;
	BCF         TXIE_bit+0, BitPos(TXIE_bit+0) 
;ModbusSlave.c,298 :: 		}
L_decodePacket46:
;ModbusSlave.c,299 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,300 :: 		}
L_decodePacket44:
;ModbusSlave.c,301 :: 		}
L_decodePacket43:
L_decodePacket42:
;ModbusSlave.c,302 :: 		if ( bytMbRxphase == 3 ) {
	MOVF        _bytMbRxphase+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket47
;ModbusSlave.c,304 :: 		bytMbRxphase = 4;
	MOVLW       4
	MOVWF       _bytMbRxphase+0 
;ModbusSlave.c,305 :: 		startTimeout(); // 2 chars
	CALL        _startTimeout+0, 0
;ModbusSlave.c,306 :: 		}
L_decodePacket47:
;ModbusSlave.c,307 :: 		if ( bytMbRxphase != 5 ) {
	MOVF        _bytMbRxphase+0, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket48
;ModbusSlave.c,309 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,310 :: 		}
L_decodePacket48:
;ModbusSlave.c,311 :: 		if ( bytMbSlaveAddress == arybytMbBuffer[0] && bytMbIndex > 3 ) {
	MOVF        _bytMbSlaveAddress+0, 0 
	XORWF       _arybytMbBuffer+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket51
	MOVF        _bytMbIndex+0, 0 
	SUBLW       3
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket51
L__decodePacket144:
;ModbusSlave.c,313 :: 		pCurrBlock = NULL;
	CLRF        ModbusSlave_pCurrBlock+0 
	CLRF        ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,315 :: 		bytMbIndex -= 2;
	MOVLW       2
	SUBWF       _bytMbIndex+0, 1 
;ModbusSlave.c,316 :: 		uintCRC = calcCRC();
	CALL        _calcCRC+0, 0
	MOVF        R0, 0 
	MOVWF       _uintCRC+0 
	MOVF        R1, 0 
	MOVWF       _uintCRC+1 
;ModbusSlave.c,318 :: 		if ( Lo(uintCRC) == arybytMbBuffer[bytMbIndex] &&
	MOVLW       _arybytMbBuffer+0
	MOVWF       FSR2 
	MOVLW       hi_addr(_arybytMbBuffer+0)
	MOVWF       FSR2H 
	MOVF        _bytMbIndex+0, 0 
	ADDWF       FSR2, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR2H, 1 
;ModbusSlave.c,319 :: 		Hi(uintCRC) == arybytMbBuffer[bytMbIndex + 1] ) {
	MOVF        _uintCRC+0, 0 
	XORWF       POSTINC2+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket54
	MOVF        _bytMbIndex+0, 0 
	ADDLW       1
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVLW       _arybytMbBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR2 
	MOVLW       hi_addr(_arybytMbBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR2H 
	MOVF        _uintCRC+1, 0 
	XORWF       POSTINC2+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket54
L__decodePacket143:
;ModbusSlave.c,321 :: 		bytMbIndex = 3;
	MOVLW       3
	MOVWF       _bytMbIndex+0 
;ModbusSlave.c,323 :: 		switch( arybytMbBuffer[1] ) {
	GOTO        L_decodePacket55
;ModbusSlave.c,324 :: 		case READ_COILS:
L_decodePacket57:
;ModbusSlave.c,325 :: 		case FORCE_SINGLE_COIL:
L_decodePacket58:
;ModbusSlave.c,326 :: 		case FORCE_MULTIPLE_COILS:
L_decodePacket59:
;ModbusSlave.c,327 :: 		if ( pCoils == NULL ) {
	MOVLW       0
	XORWF       _pCoils+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket169
	MOVLW       0
	XORWF       _pCoils+0, 0 
L__decodePacket169:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket60
;ModbusSlave.c,329 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,330 :: 		} else {
	GOTO        L_decodePacket61
L_decodePacket60:
;ModbusSlave.c,331 :: 		pCurrBlock = pCoils;
	MOVF        _pCoils+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        _pCoils+1, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,332 :: 		}
L_decodePacket61:
;ModbusSlave.c,333 :: 		break;
	GOTO        L_decodePacket56
;ModbusSlave.c,334 :: 		case READ_STATUS_INPUTS:
L_decodePacket62:
;ModbusSlave.c,335 :: 		if ( pStatusBits == NULL ) {
	MOVLW       0
	XORWF       _pStatusBits+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket170
	MOVLW       0
	XORWF       _pStatusBits+0, 0 
L__decodePacket170:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket63
;ModbusSlave.c,337 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,338 :: 		} else {
	GOTO        L_decodePacket64
L_decodePacket63:
;ModbusSlave.c,339 :: 		pCurrBlock = pStatusBits;
	MOVF        _pStatusBits+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        _pStatusBits+1, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,340 :: 		}
L_decodePacket64:
;ModbusSlave.c,341 :: 		break;
	GOTO        L_decodePacket56
;ModbusSlave.c,342 :: 		case READ_HOLDING_REGISTERS:
L_decodePacket65:
;ModbusSlave.c,343 :: 		case PRESET_SINGLE_REGISTER:
L_decodePacket66:
;ModbusSlave.c,344 :: 		case PRESET_MULTIPLE_REGISTERS:
L_decodePacket67:
;ModbusSlave.c,345 :: 		if ( pHoldingRegs == NULL ) {
	MOVLW       0
	XORWF       _pHoldingRegs+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket171
	MOVLW       0
	XORWF       _pHoldingRegs+0, 0 
L__decodePacket171:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket68
;ModbusSlave.c,347 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,348 :: 		} else {
	GOTO        L_decodePacket69
L_decodePacket68:
;ModbusSlave.c,349 :: 		pCurrBlock = pHoldingRegs;
	MOVF        _pHoldingRegs+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        _pHoldingRegs+1, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,350 :: 		}
L_decodePacket69:
;ModbusSlave.c,351 :: 		break;
	GOTO        L_decodePacket56
;ModbusSlave.c,352 :: 		case READ_INPUT_REGISTERS:
L_decodePacket70:
;ModbusSlave.c,353 :: 		if ( pInputRegs == NULL ) {
	MOVLW       0
	XORWF       _pInputRegs+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket172
	MOVLW       0
	XORWF       _pInputRegs+0, 0 
L__decodePacket172:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket71
;ModbusSlave.c,355 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,356 :: 		} else {
	GOTO        L_decodePacket72
L_decodePacket71:
;ModbusSlave.c,357 :: 		pCurrBlock = pInputRegs;
	MOVF        _pInputRegs+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        _pInputRegs+1, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,358 :: 		}
L_decodePacket72:
;ModbusSlave.c,359 :: 		break;
	GOTO        L_decodePacket56
;ModbusSlave.c,360 :: 		default:
L_decodePacket73:
;ModbusSlave.c,362 :: 		eMbExceptionCode = ILLEGAL_FUNCTION;
	MOVLW       1
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,363 :: 		break;
	GOTO        L_decodePacket56
;ModbusSlave.c,364 :: 		}
L_decodePacket55:
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket57
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket58
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket59
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket62
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket65
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket66
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       16
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket67
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket70
	GOTO        L_decodePacket73
L_decodePacket56:
;ModbusSlave.c,365 :: 		if( eMbExceptionCode == NO_EXCEPTION ) {
	MOVF        _eMbExceptionCode+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket74
;ModbusSlave.c,372 :: 		Lo(uintSAddr) = arybytMbBuffer[3];
	MOVF        _arybytMbBuffer+3, 0 
	MOVWF       decodePacket_uintSAddr_L3+0 
;ModbusSlave.c,373 :: 		Hi(uintSAddr) = arybytMbBuffer[2];
	MOVF        _arybytMbBuffer+2, 0 
	MOVWF       decodePacket_uintSAddr_L3+1 
;ModbusSlave.c,376 :: 		|| arybytMbBuffer[1] == PRESET_SINGLE_REGISTER ) {
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L__decodePacket142
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L__decodePacket142
	GOTO        L_decodePacket77
L__decodePacket142:
;ModbusSlave.c,377 :: 		uintItemCount = 1;
	MOVLW       1
	MOVWF       decodePacket_uintItemCount_L3+0 
	MOVLW       0
	MOVWF       decodePacket_uintItemCount_L3+1 
;ModbusSlave.c,378 :: 		} else {
	GOTO        L_decodePacket78
L_decodePacket77:
;ModbusSlave.c,380 :: 		Lo(uintItemCount) = arybytMbBuffer[5];
	MOVF        _arybytMbBuffer+5, 0 
	MOVWF       decodePacket_uintItemCount_L3+0 
;ModbusSlave.c,381 :: 		Hi(uintItemCount) = arybytMbBuffer[4];
	MOVF        _arybytMbBuffer+4, 0 
	MOVWF       decodePacket_uintItemCount_L3+1 
;ModbusSlave.c,382 :: 		}
L_decodePacket78:
;ModbusSlave.c,384 :: 		uintEAddr = uintSAddr + uintItemCount;
	MOVF        decodePacket_uintItemCount_L3+0, 0 
	ADDWF       decodePacket_uintSAddr_L3+0, 0 
	MOVWF       decodePacket_uintEAddr_L3+0 
	MOVF        decodePacket_uintItemCount_L3+1, 0 
	ADDWFC      decodePacket_uintSAddr_L3+1, 0 
	MOVWF       decodePacket_uintEAddr_L3+1 
;ModbusSlave.c,385 :: 		uintSAddr++;
	INFSNZ      decodePacket_uintSAddr_L3+0, 1 
	INCF        decodePacket_uintSAddr_L3+1, 1 
;ModbusSlave.c,387 :: 		while( pCurrBlock != NULL ) {
L_decodePacket79:
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket173
	MOVLW       0
	XORWF       ModbusSlave_pCurrBlock+0, 0 
L__decodePacket173:
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket80
;ModbusSlave.c,388 :: 		if ( uintSAddr >= pCurrBlock->uintAddress
	MOVLW       2
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
;ModbusSlave.c,390 :: 		pCurrBlock->uintTotal - 1)  ) {
	MOVF        R2, 0 
	SUBWF       decodePacket_uintSAddr_L3+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket174
	MOVF        R1, 0 
	SUBWF       decodePacket_uintSAddr_L3+0, 0 
L__decodePacket174:
	BTFSS       STATUS+0, 0 
	GOTO        L_decodePacket83
;ModbusSlave.c,389 :: 		&& uintEAddr <= (pCurrBlock->uintAddress +
	MOVLW       2
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
;ModbusSlave.c,390 :: 		pCurrBlock->uintTotal - 1)  ) {
	MOVLW       4
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       1
	SUBWF       R0, 0 
	MOVWF       R2 
	MOVLW       0
	SUBWFB      R1, 0 
	MOVWF       R3 
	MOVF        decodePacket_uintEAddr_L3+1, 0 
	SUBWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket175
	MOVF        decodePacket_uintEAddr_L3+0, 0 
	SUBWF       R2, 0 
L__decodePacket175:
	BTFSS       STATUS+0, 0 
	GOTO        L_decodePacket83
L__decodePacket141:
;ModbusSlave.c,391 :: 		break;
	GOTO        L_decodePacket80
;ModbusSlave.c,392 :: 		}
L_decodePacket83:
;ModbusSlave.c,393 :: 		pCurrBlock = pCurrBlock->pNext;
	MOVLW       13
	ADDWF       ModbusSlave_pCurrBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pCurrBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       ModbusSlave_pCurrBlock+1 
;ModbusSlave.c,394 :: 		}
	GOTO        L_decodePacket79
L_decodePacket80:
;ModbusSlave.c,396 :: 		switch( arybytMbBuffer[1] ) {
	GOTO        L_decodePacket84
;ModbusSlave.c,397 :: 		case READ_COILS:
L_decodePacket86:
;ModbusSlave.c,398 :: 		case READ_STATUS_INPUTS:
L_decodePacket87:
;ModbusSlave.c,399 :: 		if ( arybytMbBuffer[1] == READ_COILS ) {
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket88
;ModbusSlave.c,400 :: 		eType = COILS;
	MOVLW       1
	MOVWF       decodePacket_eType_L3+0 
;ModbusSlave.c,401 :: 		} else {
	GOTO        L_decodePacket89
L_decodePacket88:
;ModbusSlave.c,402 :: 		eType = STATUS_INPUTS;
	MOVLW       2
	MOVWF       decodePacket_eType_L3+0 
;ModbusSlave.c,403 :: 		}
L_decodePacket89:
;ModbusSlave.c,404 :: 		arybytMbBuffer[2] = packBits(eType, &arybytMbBuffer[3],
	MOVF        decodePacket_eType_L3+0, 0 
	MOVWF       FARG_ModbusSlave_packBits_eType+0 
	MOVLW       _arybytMbBuffer+3
	MOVWF       FARG_ModbusSlave_packBits_pBuffer+0 
	MOVLW       hi_addr(_arybytMbBuffer+3)
	MOVWF       FARG_ModbusSlave_packBits_pBuffer+1 
;ModbusSlave.c,405 :: 		uintSAddr, uintEAddr);
	MOVF        decodePacket_uintSAddr_L3+0, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintStart+0 
	MOVF        decodePacket_uintSAddr_L3+1, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintStart+1 
	MOVF        decodePacket_uintEAddr_L3+0, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintEnd+0 
	MOVF        decodePacket_uintEAddr_L3+1, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintEnd+1 
	CALL        ModbusSlave_packBits+0, 0
	MOVF        R0, 0 
	MOVWF       _arybytMbBuffer+2 
;ModbusSlave.c,407 :: 		if ( arybytMbBuffer[2] == 0 ) {
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket90
;ModbusSlave.c,409 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,410 :: 		} else {
	GOTO        L_decodePacket91
L_decodePacket90:
;ModbusSlave.c,411 :: 		bytMbIndex += arybytMbBuffer[2];
	MOVF        _arybytMbBuffer+2, 0 
	ADDWF       _bytMbIndex+0, 1 
;ModbusSlave.c,412 :: 		}
L_decodePacket91:
;ModbusSlave.c,413 :: 		break;
	GOTO        L_decodePacket85
;ModbusSlave.c,414 :: 		case READ_HOLDING_REGISTERS:
L_decodePacket92:
;ModbusSlave.c,415 :: 		case READ_INPUT_REGISTERS:
L_decodePacket93:
;ModbusSlave.c,416 :: 		if ( arybytMbBuffer[1] == READ_INPUT_REGISTERS ) {
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket94
;ModbusSlave.c,417 :: 		eType = INPUT_REGISTERS;
	MOVLW       4
	MOVWF       decodePacket_eType_L3+0 
;ModbusSlave.c,418 :: 		} else {
	GOTO        L_decodePacket95
L_decodePacket94:
;ModbusSlave.c,419 :: 		eType = HOLDING_REGISTERS;
	MOVLW       3
	MOVWF       decodePacket_eType_L3+0 
;ModbusSlave.c,420 :: 		}
L_decodePacket95:
;ModbusSlave.c,421 :: 		arybytMbBuffer[2] = packRegisters(eType, &arybytMbBuffer[3],
	MOVF        decodePacket_eType_L3+0, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_eType+0 
	MOVLW       _arybytMbBuffer+3
	MOVWF       FARG_ModbusSlave_packRegisters_pBuffer+0 
	MOVLW       hi_addr(_arybytMbBuffer+3)
	MOVWF       FARG_ModbusSlave_packRegisters_pBuffer+1 
;ModbusSlave.c,422 :: 		uintSAddr, uintEAddr);
	MOVF        decodePacket_uintSAddr_L3+0, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintStart+0 
	MOVF        decodePacket_uintSAddr_L3+1, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintStart+1 
	MOVF        decodePacket_uintEAddr_L3+0, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintEnd+0 
	MOVF        decodePacket_uintEAddr_L3+1, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintEnd+1 
	CALL        ModbusSlave_packRegisters+0, 0
	MOVF        R0, 0 
	MOVWF       _arybytMbBuffer+2 
;ModbusSlave.c,423 :: 		if ( arybytMbBuffer[2] == 0 ) {
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket96
;ModbusSlave.c,425 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,426 :: 		} else {
	GOTO        L_decodePacket97
L_decodePacket96:
;ModbusSlave.c,427 :: 		bytMbIndex += arybytMbBuffer[2];
	MOVF        _arybytMbBuffer+2, 0 
	ADDWF       _bytMbIndex+0, 1 
;ModbusSlave.c,428 :: 		}
L_decodePacket97:
;ModbusSlave.c,429 :: 		break;
	GOTO        L_decodePacket85
;ModbusSlave.c,430 :: 		case FORCE_SINGLE_COIL:
L_decodePacket98:
;ModbusSlave.c,431 :: 		if ( arybytMbBuffer[4] == 0xff && arybytMbBuffer[5] == 0x0 ) {
	MOVF        _arybytMbBuffer+4, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket101
	MOVF        _arybytMbBuffer+5, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket101
L__decodePacket140:
;ModbusSlave.c,433 :: 		blnState = coilState(uintSAddr, TRUE);
	MOVF        decodePacket_uintSAddr_L3+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+0 
	MOVF        decodePacket_uintSAddr_L3+1, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+1 
	MOVLW       1
	MOVWF       FARG_ModbusSlave_coilState_blnState+0 
	CALL        ModbusSlave_coilState+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_blnState_L3+0 
;ModbusSlave.c,434 :: 		} else if ( arybytMbBuffer[4] == 0x0 && arybytMbBuffer[5] == 0x0 ) {
	GOTO        L_decodePacket102
L_decodePacket101:
	MOVF        _arybytMbBuffer+4, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket105
	MOVF        _arybytMbBuffer+5, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket105
L__decodePacket139:
;ModbusSlave.c,436 :: 		blnState = coilState(uintSAddr, FALSE);
	MOVF        decodePacket_uintSAddr_L3+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+0 
	MOVF        decodePacket_uintSAddr_L3+1, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+1 
	CLRF        FARG_ModbusSlave_coilState_blnState+0 
	CALL        ModbusSlave_coilState+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_blnState_L3+0 
;ModbusSlave.c,437 :: 		}
L_decodePacket105:
L_decodePacket102:
;ModbusSlave.c,438 :: 		if ( blnState == FALSE ) {
	MOVF        decodePacket_blnState_L3+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket106
;ModbusSlave.c,440 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,441 :: 		} else {
	GOTO        L_decodePacket107
L_decodePacket106:
;ModbusSlave.c,442 :: 		bytMbIndex += 4;
	MOVLW       4
	ADDWF       _bytMbIndex+0, 1 
;ModbusSlave.c,443 :: 		}
L_decodePacket107:
;ModbusSlave.c,444 :: 		break;
	GOTO        L_decodePacket85
;ModbusSlave.c,445 :: 		case PRESET_SINGLE_REGISTER:
L_decodePacket108:
;ModbusSlave.c,446 :: 		if ( setRegister(uintSAddr, arybytMbBuffer[4],
	MOVF        decodePacket_uintSAddr_L3+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+0 
	MOVF        decodePacket_uintSAddr_L3+1, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+1 
	MOVF        _arybytMbBuffer+4, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataHi+0 
;ModbusSlave.c,447 :: 		arybytMbBuffer[5]) == FALSE ) {
	MOVF        _arybytMbBuffer+5, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataLo+0 
	CALL        ModbusSlave_setRegister+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket109
;ModbusSlave.c,449 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,450 :: 		} else {
	GOTO        L_decodePacket110
L_decodePacket109:
;ModbusSlave.c,451 :: 		bytMbIndex += 4;
	MOVLW       4
	ADDWF       _bytMbIndex+0, 1 
;ModbusSlave.c,452 :: 		}
L_decodePacket110:
;ModbusSlave.c,453 :: 		break;
	GOTO        L_decodePacket85
;ModbusSlave.c,454 :: 		case FORCE_MULTIPLE_COILS:
L_decodePacket111:
;ModbusSlave.c,456 :: 		uintItemCount > (arybytMbBuffer[6] * 8) ) {
	MOVF        decodePacket_uintItemCount_L3+1, 0 
	SUBLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket176
	MOVF        decodePacket_uintItemCount_L3+0, 0 
	SUBLW       176
L__decodePacket176:
	BTFSS       STATUS+0, 0 
	GOTO        L__decodePacket138
	MOVLW       3
	MOVWF       R0 
	MOVF        _arybytMbBuffer+6, 0 
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVF        R0, 0 
L__decodePacket177:
	BZ          L__decodePacket178
	RLCF        R1, 1 
	BCF         R1, 0 
	RLCF        R2, 1 
	ADDLW       255
	GOTO        L__decodePacket177
L__decodePacket178:
	MOVF        decodePacket_uintItemCount_L3+1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket179
	MOVF        decodePacket_uintItemCount_L3+0, 0 
	SUBWF       R1, 0 
L__decodePacket179:
	BTFSS       STATUS+0, 0 
	GOTO        L__decodePacket138
	GOTO        L_decodePacket114
L__decodePacket138:
;ModbusSlave.c,458 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,459 :: 		break;
	GOTO        L_decodePacket85
;ModbusSlave.c,460 :: 		}
L_decodePacket114:
;ModbusSlave.c,461 :: 		case PRESET_MULTIPLE_REGISTERS:
L_decodePacket115:
;ModbusSlave.c,463 :: 		uintItemCount > MAX_REGISTERS_IN_FC16) ) {
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket118
	MOVLW       0
	MOVWF       R0 
	MOVF        decodePacket_uintItemCount_L3+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket180
	MOVF        decodePacket_uintItemCount_L3+0, 0 
	SUBLW       123
L__decodePacket180:
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket118
L__decodePacket137:
;ModbusSlave.c,465 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,466 :: 		} else {
	GOTO        L_decodePacket119
L_decodePacket118:
;ModbusSlave.c,467 :: 		bytBit = 1;
	MOVLW       1
	MOVWF       decodePacket_bytBit_L3+0 
;ModbusSlave.c,468 :: 		uintOffset = 0;
	CLRF        decodePacket_uintOffset_L3+0 
	CLRF        decodePacket_uintOffset_L3+1 
;ModbusSlave.c,469 :: 		uintAddr = uintSAddr;
	MOVF        decodePacket_uintSAddr_L3+0, 0 
	MOVWF       decodePacket_uintAddr_L3+0 
	MOVF        decodePacket_uintSAddr_L3+1, 0 
	MOVWF       decodePacket_uintAddr_L3+1 
;ModbusSlave.c,471 :: 		while( uintAddr <= uintEAddr ) {
L_decodePacket120:
	MOVF        decodePacket_uintAddr_L3+1, 0 
	SUBWF       decodePacket_uintEAddr_L3+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket181
	MOVF        decodePacket_uintAddr_L3+0, 0 
	SUBWF       decodePacket_uintEAddr_L3+0, 0 
L__decodePacket181:
	BTFSS       STATUS+0, 0 
	GOTO        L_decodePacket121
;ModbusSlave.c,472 :: 		if ( arybytMbBuffer[1] == PRESET_MULTIPLE_REGISTERS ) {
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket122
;ModbusSlave.c,473 :: 		if ( setRegister(uintAddr,
	MOVF        decodePacket_uintAddr_L3+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+0 
	MOVF        decodePacket_uintAddr_L3+1, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+1 
;ModbusSlave.c,474 :: 		arybytMbBuffer[7 + uintOffset],
	MOVLW       7
	ADDWF       decodePacket_uintOffset_L3+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L3+1, 0 
	MOVWF       R1 
	MOVLW       _arybytMbBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(_arybytMbBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataHi+0 
;ModbusSlave.c,475 :: 		arybytMbBuffer[8 + uintOffset]) == FALSE ) {
	MOVLW       8
	ADDWF       decodePacket_uintOffset_L3+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L3+1, 0 
	MOVWF       R1 
	MOVLW       _arybytMbBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(_arybytMbBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataLo+0 
	CALL        ModbusSlave_setRegister+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket123
;ModbusSlave.c,476 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,477 :: 		break;
	GOTO        L_decodePacket121
;ModbusSlave.c,478 :: 		}
L_decodePacket123:
;ModbusSlave.c,479 :: 		uintOffset += 2;
	MOVLW       2
	ADDWF       decodePacket_uintOffset_L3+0, 1 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L3+1, 1 
;ModbusSlave.c,480 :: 		uintAddr++;
	INFSNZ      decodePacket_uintAddr_L3+0, 1 
	INCF        decodePacket_uintAddr_L3+1, 1 
;ModbusSlave.c,481 :: 		} else {
	GOTO        L_decodePacket124
L_decodePacket122:
;ModbusSlave.c,482 :: 		blnState = FALSE;
	CLRF        decodePacket_blnState_L3+0 
;ModbusSlave.c,483 :: 		if ( (arybytMbBuffer[7 + uintOffset] & bytBit) > 0 ) {
	MOVLW       7
	ADDWF       decodePacket_uintOffset_L3+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L3+1, 0 
	MOVWF       R1 
	MOVLW       _arybytMbBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(_arybytMbBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        decodePacket_bytBit_L3+0, 0 
	ANDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket125
;ModbusSlave.c,484 :: 		blnState = TRUE;
	MOVLW       1
	MOVWF       decodePacket_blnState_L3+0 
;ModbusSlave.c,485 :: 		}
L_decodePacket125:
;ModbusSlave.c,486 :: 		if ( coilState(uintAddr, blnState) == FALSE ) {
	MOVF        decodePacket_uintAddr_L3+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+0 
	MOVF        decodePacket_uintAddr_L3+1, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+1 
	MOVF        decodePacket_blnState_L3+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_blnState+0 
	CALL        ModbusSlave_coilState+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket126
;ModbusSlave.c,487 :: 		eMbExceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       _eMbExceptionCode+0 
;ModbusSlave.c,488 :: 		break;
	GOTO        L_decodePacket121
;ModbusSlave.c,489 :: 		}
L_decodePacket126:
;ModbusSlave.c,490 :: 		bytBit <<= 1;
	MOVF        decodePacket_bytBit_L3+0, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       decodePacket_bytBit_L3+0 
;ModbusSlave.c,491 :: 		if ( bytBit == 0 ) {
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket127
;ModbusSlave.c,492 :: 		bytBit = 1;
	MOVLW       1
	MOVWF       decodePacket_bytBit_L3+0 
;ModbusSlave.c,493 :: 		uintOffset++;
	INFSNZ      decodePacket_uintOffset_L3+0, 1 
	INCF        decodePacket_uintOffset_L3+1, 1 
;ModbusSlave.c,494 :: 		}
L_decodePacket127:
;ModbusSlave.c,495 :: 		uintAddr++;
	INFSNZ      decodePacket_uintAddr_L3+0, 1 
	INCF        decodePacket_uintAddr_L3+1, 1 
;ModbusSlave.c,496 :: 		}
L_decodePacket124:
;ModbusSlave.c,497 :: 		}
	GOTO        L_decodePacket120
L_decodePacket121:
;ModbusSlave.c,498 :: 		if ( eMbExceptionCode == NO_EXCEPTION ) {
	MOVF        _eMbExceptionCode+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket128
;ModbusSlave.c,499 :: 		bytMbIndex += 3;
	MOVLW       3
	ADDWF       _bytMbIndex+0, 1 
;ModbusSlave.c,500 :: 		}
L_decodePacket128:
;ModbusSlave.c,501 :: 		}
L_decodePacket119:
;ModbusSlave.c,502 :: 		break;
	GOTO        L_decodePacket85
;ModbusSlave.c,503 :: 		}
L_decodePacket84:
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket86
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket87
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket92
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket93
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket98
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket108
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket111
	MOVF        _arybytMbBuffer+1, 0 
	XORLW       16
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket115
L_decodePacket85:
;ModbusSlave.c,504 :: 		}
L_decodePacket74:
;ModbusSlave.c,505 :: 		if( eMbExceptionCode != NO_EXCEPTION ) {
	MOVF        _eMbExceptionCode+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket129
;ModbusSlave.c,506 :: 		arybytMbBuffer[1] |= EXCEPTION_FLAG;
	BSF         _arybytMbBuffer+1, 7 
;ModbusSlave.c,507 :: 		arybytMbBuffer[2] = (byte)eMbExceptionCode;
	MOVF        _eMbExceptionCode+0, 0 
	MOVWF       _arybytMbBuffer+2 
;ModbusSlave.c,508 :: 		eMbExceptionCode = NO_EXCEPTION;
	CLRF        _eMbExceptionCode+0 
;ModbusSlave.c,509 :: 		}
L_decodePacket129:
;ModbusSlave.c,510 :: 		if ( bytMbIndex > 0 ) {
	MOVF        _bytMbIndex+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket130
;ModbusSlave.c,512 :: 		uintCRC = calcCRC();
	CALL        _calcCRC+0, 0
	MOVF        R0, 0 
	MOVWF       _uintCRC+0 
	MOVF        R1, 0 
	MOVWF       _uintCRC+1 
;ModbusSlave.c,513 :: 		arybytMbBuffer[bytMbIndex++] = Lo(uintCRC);
	MOVLW       _arybytMbBuffer+0
	MOVWF       FSR1 
	MOVLW       hi_addr(_arybytMbBuffer+0)
	MOVWF       FSR1H 
	MOVF        _bytMbIndex+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVF        _uintCRC+0, 0 
	MOVWF       POSTINC1+0 
	INCF        _bytMbIndex+0, 1 
;ModbusSlave.c,514 :: 		arybytMbBuffer[bytMbIndex++] = Hi(uintCRC);
	MOVLW       _arybytMbBuffer+0
	MOVWF       FSR1 
	MOVLW       hi_addr(_arybytMbBuffer+0)
	MOVWF       FSR1H 
	MOVF        _bytMbIndex+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVF        _uintCRC+1, 0 
	MOVWF       POSTINC1+0 
	INCF        _bytMbIndex+0, 1 
;ModbusSlave.c,516 :: 		while( bytMbRxphase.B0 == 0 ) ;
L_decodePacket131:
	BTFSC       _bytMbRxphase+0, 0 
	GOTO        L_decodePacket132
	GOTO        L_decodePacket131
L_decodePacket132:
;ModbusSlave.c,518 :: 		CREN_bit = 0;
	BCF         CREN_bit+0, BitPos(CREN_bit+0) 
;ModbusSlave.c,519 :: 		RCIE_bit = 0;
	BCF         RCIE_bit+0, BitPos(RCIE_bit+0) 
;ModbusSlave.c,521 :: 		TXEN_bit = 1;
	BSF         TXEN_bit+0, BitPos(TXEN_bit+0) 
;ModbusSlave.c,522 :: 		Tx_dir = 1;
	BSF         Tx_dir+0, BitPos(Tx_dir+0) 
;ModbusSlave.c,524 :: 		bytMbRxphase = 128;
	MOVLW       128
	MOVWF       _bytMbRxphase+0 
;ModbusSlave.c,526 :: 		TXREG = arybytMbBuffer[0];
	MOVF        _arybytMbBuffer+0, 0 
	MOVWF       TXREG+0 
;ModbusSlave.c,528 :: 		arybytMbBuffer[0] = bytMbIndex;
	MOVF        _bytMbIndex+0, 0 
	MOVWF       _arybytMbBuffer+0 
;ModbusSlave.c,530 :: 		while( !TXIF_bit ){}
L_decodePacket133:
	BTFSC       TXIF_bit+0, BitPos(TXIF_bit+0) 
	GOTO        L_decodePacket134
	GOTO        L_decodePacket133
L_decodePacket134:
;ModbusSlave.c,531 :: 		TXREG = arybytMbBuffer[1];
	MOVF        _arybytMbBuffer+1, 0 
	MOVWF       TXREG+0 
;ModbusSlave.c,533 :: 		bytMbIndex = 2;
	MOVLW       2
	MOVWF       _bytMbIndex+0 
;ModbusSlave.c,534 :: 		TXIE_bit = 1;
	BSF         TXIE_bit+0, BitPos(TXIE_bit+0) 
;ModbusSlave.c,535 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,536 :: 		}
L_decodePacket130:
;ModbusSlave.c,537 :: 		}
L_decodePacket54:
;ModbusSlave.c,538 :: 		}
L_decodePacket51:
;ModbusSlave.c,540 :: 		bytMbIndex = 0;
	CLRF        _bytMbIndex+0 
;ModbusSlave.c,541 :: 		bytMbRxphase = 1;
	MOVLW       1
	MOVWF       _bytMbRxphase+0 
;ModbusSlave.c,542 :: 		}
L_end_decodePacket:
	RETURN      0
; end of _decodePacket
