
_interrupt:

;main.c,34 :: 		void interrupt() {
;main.c,35 :: 		decodePacket();
	CALL        _decodePacket+0, 0
;main.c,36 :: 		}
L_end_interrupt:
L__interrupt3:
	RETFIE      1
; end of _interrupt

_coilsCallback:

;main.c,41 :: 		void coilsCallback(modbusBlockDef* pBlock) {
;main.c,44 :: 		LATB = ((byte*)pBlock->paryData)[0];
	MOVLW       6
	ADDWF       FARG_coilsCallback_pBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      FARG_coilsCallback_pBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVFF       R0, FSR0
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       LATB+0 
;main.c,45 :: 		}
L_end_coilsCallback:
	RETURN      0
; end of _coilsCallback

_holdingRegCallback:

;main.c,46 :: 		void holdingRegCallback(modbusBlockDef* pBlock) {
;main.c,49 :: 		LATA = ((uint*)pBlock->paryData)[0];
	MOVLW       6
	ADDWF       FARG_holdingRegCallback_pBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      FARG_holdingRegCallback_pBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVFF       R0, FSR0
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       LATA+0 
;main.c,50 :: 		}
L_end_holdingRegCallback:
	RETURN      0
; end of _holdingRegCallback

_main:

;main.c,54 :: 		void main() {
;main.c,56 :: 		ANSELA = 0x02;             // Configure RA1 pin as analog
	MOVLW       2
	MOVWF       ANSELA+0 
;main.c,57 :: 		ANSELB = 0;
	CLRF        ANSELB+0 
;main.c,58 :: 		ANSELC = 0;
	CLRF        ANSELC+0 
;main.c,59 :: 		ANSELE = 0;
	CLRF        ANSELE+0 
;main.c,62 :: 		TRISA = 0x02;                  // Set RA1 pin as input
	MOVLW       2
	MOVWF       TRISA+0 
;main.c,63 :: 		TRISB = 0;
	CLRF        TRISB+0 
;main.c,64 :: 		TRISC = 0;
	CLRF        TRISC+0 
;main.c,65 :: 		TRISE = 0;
	CLRF        TRISE+0 
;main.c,67 :: 		TRISD = 0xff;
	MOVLW       255
	MOVWF       TRISD+0 
;main.c,69 :: 		LATB = 0;
	CLRF        LATB+0 
;main.c,70 :: 		LATC = 0;
	CLRF        LATC+0 
;main.c,71 :: 		LATE = 0;
	CLRF        LATE+0 
;main.c,73 :: 		modbusSerialInit(BAUD_115200, 1, 1);
	MOVLW       128
	MOVWF       FARG_modbusSerialInit_eBaud+0 
	MOVLW       4
	MOVWF       FARG_modbusSerialInit_eBaud+1 
	MOVLW       1
	MOVWF       FARG_modbusSerialInit_bytStopBits+0 
	MOVLW       1
	MOVWF       FARG_modbusSerialInit_eBaud+3 
	CALL        _modbusSerialInit+0, 0
;main.c,75 :: 		memset(arybytCoils,        0, sizeof(arybytCoils));
	MOVLW       main_arybytCoils+0
	MOVWF       FARG_memset_p1+0 
	MOVLW       hi_addr(main_arybytCoils+0)
	MOVWF       FARG_memset_p1+1 
	CLRF        FARG_memset_character+0 
	MOVLW       1
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;main.c,76 :: 		memset(arybytStatusBits,   0, sizeof(arybytStatusBits));
	MOVLW       main_arybytStatusBits+0
	MOVWF       FARG_memset_p1+0 
	MOVLW       hi_addr(main_arybytStatusBits+0)
	MOVWF       FARG_memset_p1+1 
	CLRF        FARG_memset_character+0 
	MOVLW       1
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;main.c,77 :: 		memset(aryuintHoldingRegs, 0, sizeof(aryuintHoldingRegs));
	MOVLW       main_aryuintHoldingRegs+0
	MOVWF       FARG_memset_p1+0 
	MOVLW       hi_addr(main_aryuintHoldingRegs+0)
	MOVWF       FARG_memset_p1+1 
	CLRF        FARG_memset_character+0 
	MOVLW       2
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;main.c,78 :: 		memset(aryuintInputRegs,   0, sizeof(aryuintInputRegs));
	MOVLW       main_aryuintInputRegs+0
	MOVWF       FARG_memset_p1+0 
	MOVLW       hi_addr(main_aryuintInputRegs+0)
	MOVWF       FARG_memset_p1+1 
	CLRF        FARG_memset_character+0 
	MOVLW       2
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;main.c,80 :: 		addModbusBlock(1, COILS,             &coilsBlock,       1, 8,
	MOVLW       1
	MOVWF       FARG_addModbusBlock_bytSlaveAddress+0 
	MOVLW       1
	MOVWF       FARG_addModbusBlock_eType+0 
	MOVLW       main_coilsBlock+0
	MOVWF       FARG_addModbusBlock_pBlock+0 
	MOVLW       hi_addr(main_coilsBlock+0)
	MOVWF       FARG_addModbusBlock_pBlock+1 
	MOVLW       1
	MOVWF       FARG_addModbusBlock_uintAddress+0 
	MOVLW       0
	MOVWF       FARG_addModbusBlock_uintAddress+1 
	MOVLW       8
	MOVWF       FARG_addModbusBlock_uintTotal+0 
	MOVLW       0
	MOVWF       FARG_addModbusBlock_uintTotal+1 
;main.c,81 :: 		(void*)arybytCoils, coilsCallback);
	MOVLW       main_arybytCoils+0
	MOVWF       FARG_addModbusBlock_paryData+0 
	MOVLW       hi_addr(main_arybytCoils+0)
	MOVWF       FARG_addModbusBlock_paryData+1 
	MOVLW       _coilsCallback+0
	MOVWF       FARG_addModbusBlock_pCallback+0 
	MOVLW       hi_addr(_coilsCallback+0)
	MOVWF       FARG_addModbusBlock_pCallback+1 
	MOVLW       FARG_coilsCallback_pBlock+0
	MOVWF       FARG_addModbusBlock_pCallback+2 
	MOVLW       hi_addr(FARG_coilsCallback_pBlock+0)
	MOVWF       FARG_addModbusBlock_pCallback+3 
	CALL        _addModbusBlock+0, 0
;main.c,82 :: 		addModbusBlock(1, STATUS_INPUTS,     &statusBitsBlock,  1, 8,
	MOVLW       1
	MOVWF       FARG_addModbusBlock_bytSlaveAddress+0 
	MOVLW       2
	MOVWF       FARG_addModbusBlock_eType+0 
	MOVLW       main_statusBitsBlock+0
	MOVWF       FARG_addModbusBlock_pBlock+0 
	MOVLW       hi_addr(main_statusBitsBlock+0)
	MOVWF       FARG_addModbusBlock_pBlock+1 
	MOVLW       1
	MOVWF       FARG_addModbusBlock_uintAddress+0 
	MOVLW       0
	MOVWF       FARG_addModbusBlock_uintAddress+1 
	MOVLW       8
	MOVWF       FARG_addModbusBlock_uintTotal+0 
	MOVLW       0
	MOVWF       FARG_addModbusBlock_uintTotal+1 
;main.c,83 :: 		(void*)arybytStatusBits, NULL);
	MOVLW       main_arybytStatusBits+0
	MOVWF       FARG_addModbusBlock_paryData+0 
	MOVLW       hi_addr(main_arybytStatusBits+0)
	MOVWF       FARG_addModbusBlock_paryData+1 
	CLRF        FARG_addModbusBlock_pCallback+0 
	CLRF        FARG_addModbusBlock_pCallback+1 
	CLRF        FARG_addModbusBlock_pCallback+2 
	CLRF        FARG_addModbusBlock_pCallback+3 
	CALL        _addModbusBlock+0, 0
;main.c,84 :: 		addModbusBlock(1, HOLDING_REGISTERS, &holdingRegsBlock, 1, 1,
	MOVLW       1
	MOVWF       FARG_addModbusBlock_bytSlaveAddress+0 
	MOVLW       3
	MOVWF       FARG_addModbusBlock_eType+0 
	MOVLW       main_holdingRegsBlock+0
	MOVWF       FARG_addModbusBlock_pBlock+0 
	MOVLW       hi_addr(main_holdingRegsBlock+0)
	MOVWF       FARG_addModbusBlock_pBlock+1 
	MOVLW       1
	MOVWF       FARG_addModbusBlock_uintAddress+0 
	MOVLW       0
	MOVWF       FARG_addModbusBlock_uintAddress+1 
	MOVLW       1
	MOVWF       FARG_addModbusBlock_uintTotal+0 
	MOVLW       0
	MOVWF       FARG_addModbusBlock_uintTotal+1 
;main.c,85 :: 		(void*)aryuintHoldingRegs, holdingRegCallback);
	MOVLW       main_aryuintHoldingRegs+0
	MOVWF       FARG_addModbusBlock_paryData+0 
	MOVLW       hi_addr(main_aryuintHoldingRegs+0)
	MOVWF       FARG_addModbusBlock_paryData+1 
	MOVLW       _holdingRegCallback+0
	MOVWF       FARG_addModbusBlock_pCallback+0 
	MOVLW       hi_addr(_holdingRegCallback+0)
	MOVWF       FARG_addModbusBlock_pCallback+1 
	MOVLW       FARG_holdingRegCallback_pBlock+0
	MOVWF       FARG_addModbusBlock_pCallback+2 
	MOVLW       hi_addr(FARG_holdingRegCallback_pBlock+0)
	MOVWF       FARG_addModbusBlock_pCallback+3 
	CALL        _addModbusBlock+0, 0
;main.c,86 :: 		addModbusBlock(1, INPUT_REGISTERS,   &inputRegsBlock,   1, 1,
	MOVLW       1
	MOVWF       FARG_addModbusBlock_bytSlaveAddress+0 
	MOVLW       4
	MOVWF       FARG_addModbusBlock_eType+0 
	MOVLW       main_inputRegsBlock+0
	MOVWF       FARG_addModbusBlock_pBlock+0 
	MOVLW       hi_addr(main_inputRegsBlock+0)
	MOVWF       FARG_addModbusBlock_pBlock+1 
	MOVLW       1
	MOVWF       FARG_addModbusBlock_uintAddress+0 
	MOVLW       0
	MOVWF       FARG_addModbusBlock_uintAddress+1 
	MOVLW       1
	MOVWF       FARG_addModbusBlock_uintTotal+0 
	MOVLW       0
	MOVWF       FARG_addModbusBlock_uintTotal+1 
;main.c,87 :: 		(void*)aryuintInputRegs, NULL);
	MOVLW       main_aryuintInputRegs+0
	MOVWF       FARG_addModbusBlock_paryData+0 
	MOVLW       hi_addr(main_aryuintInputRegs+0)
	MOVWF       FARG_addModbusBlock_paryData+1 
	CLRF        FARG_addModbusBlock_pCallback+0 
	CLRF        FARG_addModbusBlock_pCallback+1 
	CLRF        FARG_addModbusBlock_pCallback+2 
	CLRF        FARG_addModbusBlock_pCallback+3 
	CALL        _addModbusBlock+0, 0
;main.c,89 :: 		while (1) {
L_main0:
;main.c,91 :: 		arybytStatusBits[0] = PORTB;
	MOVF        PORTB+0, 0 
	MOVWF       main_arybytStatusBits+0 
;main.c,93 :: 		aryuintInputRegs[0] = ADC_Read(1);  // get ADC value from 1st channel
	MOVLW       1
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       main_aryuintInputRegs+0 
	MOVF        R1, 0 
	MOVWF       main_aryuintInputRegs+1 
;main.c,95 :: 		serviceIOBlocks();
	CALL        _serviceIOBlocks+0, 0
;main.c,96 :: 		}
	GOTO        L_main0
;main.c,97 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
